basic = require("lib.basic")
hash = require("lib.hash")

local pwHash = ""
local config = {}

local function setConfig()
  basic.writeToFile("/brulijam/config/systemlock.config", textutils.serialize(config))
end

local function createPwHash()
  local inputConfirmed = false
  while not inputConfirmed do
    --basic.clearDisplay()
    write("Create a new password: ")
    local input = read("*")
    pwHash = hash.digestStr(input .. os.getComputerID())

    write("Confirm new password: ")
    local input2 = read("*")
    local input2Hash = hash.digestStr(input2 .. os.getComputerID())
    print(pwHash)
    print(input2Hash)
    print(input)
    print(input2)
    local inputConfirmed = pwHash == input2
  end
  return pwHash
end

local function getConfig()
  if not fs.exists "/brulijam/config/systemlock.config" then
    config["locked"] = true
    config["pwHash"] = createPwHash()
    config["keepUnlockedFor"] = 600
    setConfig()
  else
    config = basic.readFileAll("brulijam/config/systemlock.config")
    config = textutils.unserialize(config)
  end
  return config
end


local function inputTimeout()
  sleep(10)
  eventTimeout = true
end

local function inputPrompt()
  write("Enter Password: ")
  inputHash = hash.digestStr(read("*") .. os.getComputerID())
end


local function unlockDevice()
  config = getConfig()
  pwHash = config["pwHash"]
  inputHash = ""
  eventTimeout = false

  while true do
    parallel.waitForAny(inputTimeout, inputPrompt)
    local pwCorrect = pwHash == inputHash

    if pwCorrect then --correct input
      config["locked"] = false
      setConfig()
      print("[Unlocked]")
      sleep(0.2)
      break
    elseif eventTimeout then --timeout
      config["locked"] = true
      setConfig()
      print("Timeout...")
      sleep(0.5)
      os.reboot()
    else --wrong input
      config["locked"] = true
      setConfig()
      print("Wrong password...")
      sleep(1)
      print("Rebooting...")
      sleep(1)
      os.reboot()
    end
  end
end

local function shellRun()
  shell.run("shell")
end

local function shellStopTimer()
  while true do
		if timer < 1 then
			os.reboot()
		end
		timer = timer - 1
		sleep(1)
	end
end

local function shellStopKeyEvent()
  eventName = nil
  while true do
		eventName, _ = os.pullEvent("key")
		if eventName == "key" then
			timer = config["keepUnlockedFor"]
		end
	end
end

local function shellStopCheck()
  parallel.waitForAny(shellStopTimer, shellStopKeyEvent)
end

local function main()
  config = getConfig()
  config["locked"] = true
  setConfig()
  timer = config["keepUnlockedFor"]

  unlockDevice()

  parallel.waitForAny(shellRun, shellStopCheck)
  os.reboot()
end

main()